# Moonrope - the self-documenting API

Moonrope is an API server & client tool for Ruby/Rack applications. It
provides everything you need to create an API within your application and
have easy to use client libraries provided without any development.

Not only does it provide a formal structure for your API, it will also generate
lovely looking documentation files for develpers to work with.

This repository is the server-side library which allows you to easily define
your API actions & data structures and serve them out using Rack middleware.

* [Documentation](http://rdoc.info/github/viaduct/moonrope/master/frames)
* [Travis CI](https://travis-ci.org/viaduct/moonrope)

![Screenshot](https://s.adamcooke.io/16/VJpLoJku.png)

## Documentation

* [Introduction](https://github.com/adamcooke/moonrope/blob/master/docs/introduction.md)
* [Controllers & Actions](https://github.com/adamcooke/moonrope/blob/master/docs/controllers.md)
* [Structures](https://github.com/adamcooke/moonrope/blob/master/docs/structures.md)
* [Authentication](https://github.com/adamcooke/moonrope/blob/master/docs/authentication.md)
* [Exceptions](https://github.com/adamcooke/moonrope/blob/master/docs/exceptions.md)
